---
title: Update a retention filter
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > APM Retention Filters
---

# Update a retention filter{% #update-a-retention-filter %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                      |
| ----------------- | --------------------------------------------------------------------------------- |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/apm/config/retention-filters/{filter_id}      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/apm/config/retention-filters/{filter_id}      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/apm/config/retention-filters/{filter_id}  |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id}     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/apm/config/retention-filters/{filter_id} |

### Overview



Update a retention filter from your organization.

Default filters (filters with types spans-errors-sampling-processor and spans-appsec-sampling-processor) cannot be renamed or removed.
This endpoint requires the `apm_retention_filter_write` permission.


### Arguments

#### Path Parameters

| Name                        | Type   | Description                     |
| --------------------------- | ------ | ------------------------------- |
| filter_id [*required*] | string | The ID of the retention filter. |

### Request

#### Body Data (required)

The updated definition of the retention filter.

{% tab title="Model" %}

| Parent field | Field                         | Type    | Description                                                                                                                                         |
| ------------ | ----------------------------- | ------- | --------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object  | The body of the retention filter to be updated.                                                                                                     |
| data         | attributes [*required*]  | object  | The object describing the configuration of the retention filter to create/update.                                                                   |
| attributes   | enabled [*required*]     | boolean | Enable/Disable the retention filter.                                                                                                                |
| attributes   | filter [*required*]      | object  | The spans filter. Spans matching this filter will be indexed and stored.                                                                            |
| filter       | query [*required*]       | string  | The search query - following the [span search syntax](https://docs.datadoghq.com/tracing/trace_explorer/query_syntax.md).                           |
| attributes   | filter_type [*required*] | enum    | The type of retention filter. Allowed enum values: `spans-sampling-processor,spans-errors-sampling-processor,spans-appsec-sampling-processor`       |
| attributes   | name [*required*]        | string  | The name of the retention filter.                                                                                                                   |
| attributes   | rate [*required*]        | double  | Sample rate to apply to spans going through this retention filter. A value of 1.0 keeps all spans matching the query.                               |
| attributes   | trace_rate                    | double  | Sample rate to apply to traces containing spans going through this retention filter. A value of 1.0 keeps all traces with spans matching the query. |
| data         | id [*required*]          | string  | The ID of the retention filter.                                                                                                                     |
| data         | type [*required*]        | enum    | The type of the resource. Allowed enum values: `apm_retention_filter`                                                                               |

{% /tab %}

{% tab title="Example" %}
##### 

```json
{
  "data": {
    "attributes": {
      "name": "test",
      "rate": 0.9,
      "filter": {
        "query": "@_top_level:1 test:service-demo"
      },
      "enabled": true,
      "filter_type": "spans-sampling-processor"
    },
    "id": "test-id",
    "type": "apm_retention_filter"
  }
}
```

##### 

```json
{
  "data": {
    "attributes": {
      "name": "test",
      "rate": 0.9,
      "trace_rate": 1.0,
      "filter": {
        "query": "@_top_level:1 test:service-demo"
      },
      "enabled": true,
      "filter_type": "spans-sampling-processor"
    },
    "id": "test-id",
    "type": "apm_retention_filter"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The retention filters definition.

| Parent field | Field                        | Type    | Description                                                                                                                                         |
| ------------ | ---------------------------- | ------- | --------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data                         | object  | The definition of the retention filter.                                                                                                             |
| data         | attributes [*required*] | object  | The attributes of the retention filter.                                                                                                             |
| attributes   | created_at                   | int64   | The creation timestamp of the retention filter.                                                                                                     |
| attributes   | created_by                   | string  | The creator of the retention filter.                                                                                                                |
| attributes   | editable                     | boolean | Shows whether the filter can be edited.                                                                                                             |
| attributes   | enabled                      | boolean | The status of the retention filter (Enabled/Disabled).                                                                                              |
| attributes   | execution_order              | int64   | The execution order of the retention filter.                                                                                                        |
| attributes   | filter                       | object  | The spans filter used to index spans.                                                                                                               |
| filter       | query                        | string  | The search query - following the [span search syntax](https://docs.datadoghq.com/tracing/trace_explorer/query_syntax.md).                           |
| attributes   | filter_type                  | enum    | The type of retention filter. Allowed enum values: `spans-sampling-processor,spans-errors-sampling-processor,spans-appsec-sampling-processor`       |
| attributes   | modified_at                  | int64   | The modification timestamp of the retention filter.                                                                                                 |
| attributes   | modified_by                  | string  | The modifier of the retention filter.                                                                                                               |
| attributes   | name                         | string  | The name of the retention filter.                                                                                                                   |
| attributes   | rate                         | double  | Sample rate to apply to spans going through this retention filter. A value of 1.0 keeps all spans matching the query.                               |
| attributes   | trace_rate                   | double  | Sample rate to apply to traces containing spans going through this retention filter. A value of 1.0 keeps all traces with spans matching the query. |
| data         | id [*required*]         | string  | The ID of the retention filter.                                                                                                                     |
| data         | type [*required*]       | enum    | The type of the resource. Allowed enum values: `apm_retention_filter`                                                                               |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "integer",
      "created_by": "string",
      "editable": true,
      "enabled": true,
      "execution_order": "integer",
      "filter": {
        "query": "@http.status_code:200 service:my-service"
      },
      "filter_type": "spans-sampling-processor",
      "modified_at": "integer",
      "modified_by": "string",
      "name": "my retention filter",
      "rate": 1,
      "trace_rate": 1
    },
    "id": "7RBOb7dLSYWI01yc3pIH8w",
    "type": "apm_retention_filter"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Not Authorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Path parameters export filter_id="CHANGE_ME" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/apm/config/retention-filters/${filter_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "enabled": true,
      "filter": {
        "query": "@http.status_code:200 service:my-service"
      },
      "filter_type": "spans-sampling-processor",
      "name": "my retention filter",
      "rate": 1,
      "trace_rate": 1
    },
    "id": "retention-filter-id",
    "type": "apm_retention_filter"
  }
}
EOF 
                        
##### 
                          \## default
# 
 \# Path parameters export filter_id="CHANGE_ME" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/apm/config/retention-filters/${filter_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "enabled": true,
      "filter": {
        "query": "@http.status_code:200 service:my-service"
      },
      "filter_type": "spans-sampling-processor",
      "name": "my retention filter",
      "rate": 1,
      "trace_rate": 1
    },
    "id": "retention-filter-id",
    "type": "apm_retention_filter"
  }
}
EOF 
                        
##### 

```go
// Update a retention filter returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "retention_filter" in the system
	RetentionFilterDataID := os.Getenv("RETENTION_FILTER_DATA_ID")

	body := datadogV2.RetentionFilterUpdateRequest{
		Data: datadogV2.RetentionFilterUpdateData{
			Attributes: datadogV2.RetentionFilterUpdateAttributes{
				Name: "test",
				Rate: 0.9,
				Filter: datadogV2.SpansFilterCreate{
					Query: "@_top_level:1 test:service-demo",
				},
				Enabled:    true,
				FilterType: datadogV2.RETENTIONFILTERALLTYPE_SPANS_SAMPLING_PROCESSOR,
			},
			Id:   "test-id",
			Type: datadogV2.APMRETENTIONFILTERTYPE_apm_retention_filter,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewAPMRetentionFiltersApi(apiClient)
	resp, r, err := api.UpdateApmRetentionFilter(ctx, RetentionFilterDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `APMRetentionFiltersApi.UpdateApmRetentionFilter`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `APMRetentionFiltersApi.UpdateApmRetentionFilter`:\n%s\n", responseContent)
}
```

##### 

```go
// Update a retention filter with trace rate returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "retention_filter" in the system
	RetentionFilterDataID := os.Getenv("RETENTION_FILTER_DATA_ID")

	body := datadogV2.RetentionFilterUpdateRequest{
		Data: datadogV2.RetentionFilterUpdateData{
			Attributes: datadogV2.RetentionFilterUpdateAttributes{
				Name:      "test",
				Rate:      0.9,
				TraceRate: datadog.PtrFloat64(1.0),
				Filter: datadogV2.SpansFilterCreate{
					Query: "@_top_level:1 test:service-demo",
				},
				Enabled:    true,
				FilterType: datadogV2.RETENTIONFILTERALLTYPE_SPANS_SAMPLING_PROCESSOR,
			},
			Id:   "test-id",
			Type: datadogV2.APMRETENTIONFILTERTYPE_apm_retention_filter,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewAPMRetentionFiltersApi(apiClient)
	resp, r, err := api.UpdateApmRetentionFilter(ctx, RetentionFilterDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `APMRetentionFiltersApi.UpdateApmRetentionFilter`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `APMRetentionFiltersApi.UpdateApmRetentionFilter`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Update a retention filter returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ApmRetentionFiltersApi;
import com.datadog.api.client.v2.model.ApmRetentionFilterType;
import com.datadog.api.client.v2.model.RetentionFilterAllType;
import com.datadog.api.client.v2.model.RetentionFilterResponse;
import com.datadog.api.client.v2.model.RetentionFilterUpdateAttributes;
import com.datadog.api.client.v2.model.RetentionFilterUpdateData;
import com.datadog.api.client.v2.model.RetentionFilterUpdateRequest;
import com.datadog.api.client.v2.model.SpansFilterCreate;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ApmRetentionFiltersApi apiInstance = new ApmRetentionFiltersApi(defaultClient);

    // there is a valid "retention_filter" in the system
    String RETENTION_FILTER_DATA_ID = System.getenv("RETENTION_FILTER_DATA_ID");

    RetentionFilterUpdateRequest body =
        new RetentionFilterUpdateRequest()
            .data(
                new RetentionFilterUpdateData()
                    .attributes(
                        new RetentionFilterUpdateAttributes()
                            .name("test")
                            .rate(0.9)
                            .filter(
                                new SpansFilterCreate().query("@_top_level:1 test:service-demo"))
                            .enabled(true)
                            .filterType(RetentionFilterAllType.SPANS_SAMPLING_PROCESSOR))
                    .id("test-id")
                    .type(ApmRetentionFilterType.apm_retention_filter));

    try {
      RetentionFilterResponse result =
          apiInstance.updateApmRetentionFilter(RETENTION_FILTER_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ApmRetentionFiltersApi#updateApmRetentionFilter");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

##### 

```java
// Update a retention filter with trace rate returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ApmRetentionFiltersApi;
import com.datadog.api.client.v2.model.ApmRetentionFilterType;
import com.datadog.api.client.v2.model.RetentionFilterAllType;
import com.datadog.api.client.v2.model.RetentionFilterResponse;
import com.datadog.api.client.v2.model.RetentionFilterUpdateAttributes;
import com.datadog.api.client.v2.model.RetentionFilterUpdateData;
import com.datadog.api.client.v2.model.RetentionFilterUpdateRequest;
import com.datadog.api.client.v2.model.SpansFilterCreate;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ApmRetentionFiltersApi apiInstance = new ApmRetentionFiltersApi(defaultClient);

    // there is a valid "retention_filter" in the system
    String RETENTION_FILTER_DATA_ID = System.getenv("RETENTION_FILTER_DATA_ID");

    RetentionFilterUpdateRequest body =
        new RetentionFilterUpdateRequest()
            .data(
                new RetentionFilterUpdateData()
                    .attributes(
                        new RetentionFilterUpdateAttributes()
                            .name("test")
                            .rate(0.9)
                            .traceRate(1.0)
                            .filter(
                                new SpansFilterCreate().query("@_top_level:1 test:service-demo"))
                            .enabled(true)
                            .filterType(RetentionFilterAllType.SPANS_SAMPLING_PROCESSOR))
                    .id("test-id")
                    .type(ApmRetentionFilterType.apm_retention_filter));

    try {
      RetentionFilterResponse result =
          apiInstance.updateApmRetentionFilter(RETENTION_FILTER_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ApmRetentionFiltersApi#updateApmRetentionFilter");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```python
"""
Update a retention filter returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.apm_retention_filters_api import APMRetentionFiltersApi
from datadog_api_client.v2.model.apm_retention_filter_type import ApmRetentionFilterType
from datadog_api_client.v2.model.retention_filter_all_type import RetentionFilterAllType
from datadog_api_client.v2.model.retention_filter_update_attributes import RetentionFilterUpdateAttributes
from datadog_api_client.v2.model.retention_filter_update_data import RetentionFilterUpdateData
from datadog_api_client.v2.model.retention_filter_update_request import RetentionFilterUpdateRequest
from datadog_api_client.v2.model.spans_filter_create import SpansFilterCreate

# there is a valid "retention_filter" in the system
RETENTION_FILTER_DATA_ID = environ["RETENTION_FILTER_DATA_ID"]

body = RetentionFilterUpdateRequest(
    data=RetentionFilterUpdateData(
        attributes=RetentionFilterUpdateAttributes(
            name="test",
            rate=0.9,
            filter=SpansFilterCreate(
                query="@_top_level:1 test:service-demo",
            ),
            enabled=True,
            filter_type=RetentionFilterAllType.SPANS_SAMPLING_PROCESSOR,
        ),
        id="test-id",
        type=ApmRetentionFilterType.apm_retention_filter,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = APMRetentionFiltersApi(api_client)
    response = api_instance.update_apm_retention_filter(filter_id=RETENTION_FILTER_DATA_ID, body=body)

    print(response)
```

##### 

```python
"""
Update a retention filter with trace rate returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.apm_retention_filters_api import APMRetentionFiltersApi
from datadog_api_client.v2.model.apm_retention_filter_type import ApmRetentionFilterType
from datadog_api_client.v2.model.retention_filter_all_type import RetentionFilterAllType
from datadog_api_client.v2.model.retention_filter_update_attributes import RetentionFilterUpdateAttributes
from datadog_api_client.v2.model.retention_filter_update_data import RetentionFilterUpdateData
from datadog_api_client.v2.model.retention_filter_update_request import RetentionFilterUpdateRequest
from datadog_api_client.v2.model.spans_filter_create import SpansFilterCreate

# there is a valid "retention_filter" in the system
RETENTION_FILTER_DATA_ID = environ["RETENTION_FILTER_DATA_ID"]

body = RetentionFilterUpdateRequest(
    data=RetentionFilterUpdateData(
        attributes=RetentionFilterUpdateAttributes(
            name="test",
            rate=0.9,
            trace_rate=1.0,
            filter=SpansFilterCreate(
                query="@_top_level:1 test:service-demo",
            ),
            enabled=True,
            filter_type=RetentionFilterAllType.SPANS_SAMPLING_PROCESSOR,
        ),
        id="test-id",
        type=ApmRetentionFilterType.apm_retention_filter,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = APMRetentionFiltersApi(api_client)
    response = api_instance.update_apm_retention_filter(filter_id=RETENTION_FILTER_DATA_ID, body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Update a retention filter returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::APMRetentionFiltersAPI.new

# there is a valid "retention_filter" in the system
RETENTION_FILTER_DATA_ID = ENV["RETENTION_FILTER_DATA_ID"]

body = DatadogAPIClient::V2::RetentionFilterUpdateRequest.new({
  data: DatadogAPIClient::V2::RetentionFilterUpdateData.new({
    attributes: DatadogAPIClient::V2::RetentionFilterUpdateAttributes.new({
      name: "test",
      rate: 0.9,
      filter: DatadogAPIClient::V2::SpansFilterCreate.new({
        query: "@_top_level:1 test:service-demo",
      }),
      enabled: true,
      filter_type: DatadogAPIClient::V2::RetentionFilterAllType::SPANS_SAMPLING_PROCESSOR,
    }),
    id: "test-id",
    type: DatadogAPIClient::V2::ApmRetentionFilterType::APM_RETENTION_FILTER,
  }),
})
p api_instance.update_apm_retention_filter(RETENTION_FILTER_DATA_ID, body)
```

##### 

```ruby
# Update a retention filter with trace rate returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::APMRetentionFiltersAPI.new

# there is a valid "retention_filter" in the system
RETENTION_FILTER_DATA_ID = ENV["RETENTION_FILTER_DATA_ID"]

body = DatadogAPIClient::V2::RetentionFilterUpdateRequest.new({
  data: DatadogAPIClient::V2::RetentionFilterUpdateData.new({
    attributes: DatadogAPIClient::V2::RetentionFilterUpdateAttributes.new({
      name: "test",
      rate: 0.9,
      trace_rate: 1.0,
      filter: DatadogAPIClient::V2::SpansFilterCreate.new({
        query: "@_top_level:1 test:service-demo",
      }),
      enabled: true,
      filter_type: DatadogAPIClient::V2::RetentionFilterAllType::SPANS_SAMPLING_PROCESSOR,
    }),
    id: "test-id",
    type: DatadogAPIClient::V2::ApmRetentionFilterType::APM_RETENTION_FILTER,
  }),
})
p api_instance.update_apm_retention_filter(RETENTION_FILTER_DATA_ID, body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```rust
// Update a retention filter returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_apm_retention_filters::APMRetentionFiltersAPI;
use datadog_api_client::datadogV2::model::ApmRetentionFilterType;
use datadog_api_client::datadogV2::model::RetentionFilterAllType;
use datadog_api_client::datadogV2::model::RetentionFilterUpdateAttributes;
use datadog_api_client::datadogV2::model::RetentionFilterUpdateData;
use datadog_api_client::datadogV2::model::RetentionFilterUpdateRequest;
use datadog_api_client::datadogV2::model::SpansFilterCreate;

#[tokio::main]
async fn main() {
    // there is a valid "retention_filter" in the system
    let retention_filter_data_id = std::env::var("RETENTION_FILTER_DATA_ID").unwrap();
    let body = RetentionFilterUpdateRequest::new(RetentionFilterUpdateData::new(
        RetentionFilterUpdateAttributes::new(
            true,
            SpansFilterCreate::new("@_top_level:1 test:service-demo".to_string()),
            RetentionFilterAllType::SPANS_SAMPLING_PROCESSOR,
            "test".to_string(),
            0.9,
        ),
        "test-id".to_string(),
        ApmRetentionFilterType::apm_retention_filter,
    ));
    let configuration = datadog::Configuration::new();
    let api = APMRetentionFiltersAPI::with_config(configuration);
    let resp = api
        .update_apm_retention_filter(retention_filter_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

##### 

```rust
// Update a retention filter with trace rate returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_apm_retention_filters::APMRetentionFiltersAPI;
use datadog_api_client::datadogV2::model::ApmRetentionFilterType;
use datadog_api_client::datadogV2::model::RetentionFilterAllType;
use datadog_api_client::datadogV2::model::RetentionFilterUpdateAttributes;
use datadog_api_client::datadogV2::model::RetentionFilterUpdateData;
use datadog_api_client::datadogV2::model::RetentionFilterUpdateRequest;
use datadog_api_client::datadogV2::model::SpansFilterCreate;

#[tokio::main]
async fn main() {
    // there is a valid "retention_filter" in the system
    let retention_filter_data_id = std::env::var("RETENTION_FILTER_DATA_ID").unwrap();
    let body = RetentionFilterUpdateRequest::new(RetentionFilterUpdateData::new(
        RetentionFilterUpdateAttributes::new(
            true,
            SpansFilterCreate::new("@_top_level:1 test:service-demo".to_string()),
            RetentionFilterAllType::SPANS_SAMPLING_PROCESSOR,
            "test".to_string(),
            0.9,
        )
        .trace_rate(1.0 as f64),
        "test-id".to_string(),
        ApmRetentionFilterType::apm_retention_filter,
    ));
    let configuration = datadog::Configuration::new();
    let api = APMRetentionFiltersAPI::with_config(configuration);
    let resp = api
        .update_apm_retention_filter(retention_filter_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Update a retention filter returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.APMRetentionFiltersApi(configuration);

// there is a valid "retention_filter" in the system
const RETENTION_FILTER_DATA_ID = process.env.RETENTION_FILTER_DATA_ID as string;

const params: v2.APMRetentionFiltersApiUpdateApmRetentionFilterRequest = {
  body: {
    data: {
      attributes: {
        name: "test",
        rate: 0.9,
        filter: {
          query: "@_top_level:1 test:service-demo",
        },
        enabled: true,
        filterType: "spans-sampling-processor",
      },
      id: "test-id",
      type: "apm_retention_filter",
    },
  },
  filterId: RETENTION_FILTER_DATA_ID,
};

apiInstance
  .updateApmRetentionFilter(params)
  .then((data: v2.RetentionFilterResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

##### 

```typescript
/**
 * Update a retention filter with trace rate returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.APMRetentionFiltersApi(configuration);

// there is a valid "retention_filter" in the system
const RETENTION_FILTER_DATA_ID = process.env.RETENTION_FILTER_DATA_ID as string;

const params: v2.APMRetentionFiltersApiUpdateApmRetentionFilterRequest = {
  body: {
    data: {
      attributes: {
        name: "test",
        rate: 0.9,
        traceRate: 1.0,
        filter: {
          query: "@_top_level:1 test:service-demo",
        },
        enabled: true,
        filterType: "spans-sampling-processor",
      },
      id: "test-id",
      type: "apm_retention_filter",
    },
  },
  filterId: RETENTION_FILTER_DATA_ID,
};

apiInstance
  .updateApmRetentionFilter(params)
  .then((data: v2.RetentionFilterResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
